#MenuTitle: flipper
# -*- coding: utf-8 -*-
__doc__="""flips along middlepoint"""
from math import fabs


def flippingAlongMiddlepoint(Nodes,middlePointX,middlePointY):
	Nodes.x = middlePointX-(Nodes.x-middlePointX)
	Nodes.y = middlePointY-(Nodes.y-middlePointY)
	pass
def flip_without_comp():

	#creates middlepoint's values (x,y)
	allXnodes = []
	allYnodes = []
	for myPaths in myLetters.paths:

		for myNodes in myPaths.nodes:  
			allXnodes.append(myNodes.x)	
			allYnodes.append(myNodes.y)	
		
	minXvalue = min(allXnodes)
	maxXvalue = max(allXnodes)
	#x value of the middle point:
	middlePointX = maxXvalue - (maxXvalue - minXvalue)/2
	
	
	
		
	minYvalue = min(allYnodes)
	maxYvalue = max(allYnodes)
	#y value of the middle point:
	middlePointY = maxYvalue - (maxYvalue - minYvalue)/2
	
	
	#flipping:
	for myPaths in myLetters.paths:

		for myNodes in myPaths.nodes:  
			flippingAlongMiddlepoint(myNodes,middlePointX,middlePointY);

	
	pass
def flip_with_comp():
	
	
	#creates middlepoint's values (x,y)	
	allXnodes = []
	allYnodes = []
	for myPaths in myLetters.paths:
			for myNodes in myPaths.nodes:  
				allXnodes.append(myNodes.x)	
				allYnodes.append(myNodes.y)

	Components = myLetters.components
	for specComponent in Components:
		#calculets extreme values for components
		bounds = specComponent.bounds		
		
		componentsLeftEx = bounds.origin.x
		componentsRightEx = componentsLeftEx+bounds.size.width
		allXnodes.append(componentsLeftEx)
		allXnodes.append(componentsRightEx)

		componentsBottomEx = bounds.origin.y
		componentsTopEx = componentsBottomEx+bounds.size.height
		allYnodes.append(componentsBottomEx)
		allYnodes.append(componentsTopEx)

		
		minXvalue = min(allXnodes)
		maxXvalue = max(allXnodes)
		
		#x value of the middle point:
		middlePointX = maxXvalue - (maxXvalue - minXvalue)/2
	
		
		minYvalue = min(allYnodes)
		maxYvalue = max(allYnodes)
		
		#y value of the middle point:
		middlePointY = maxYvalue - (maxYvalue - minYvalue)/2
		
		#######

		
		t = specComponent.transform
		
		#Flips components
		flippingAlongMiddlepoint(specComponent,middlePointX,middlePointY);

		#I THINK THAT HERE COULD BE THE PROBLEM, but I'm not sure
		t = (-t[0], t[1], t[2], -t[3], specComponent.x, specComponent.y )

		specComponent.transform = t		

		
		####flips paths:
		
		for myPaths in myLetters.paths:
			for myNodes in myPaths.nodes:  
				flippingAlongMiddlepoint(myNodes,middlePointX,middlePointY);
	pass				


selectedLayer = Font.selectedLayers[0]

for myLetters in selectedLayer.parent.layers:
	Components = myLetters.components
	
	if len(Components) == 0:
		flip_without_comp();
	else:
		flip_with_comp();
	flippedLSB = myLetters.RSB
	flippedRSB = myLetters.LSB
	myLetters.LSB = flippedLSB
	myLetters.RSB = flippedRSB